#!/usr/bin/perl
#MEOW1

#getting the input from STDIN, looping all the way
#then processing data, and then output them via HEREDOC template
#There are 4 modes:
#0=Initial  1=Header  2=Body  3=End
$mode = 0;
$image = '';
$body = '';
$footer = '';

sub resetvar {
$image = '';
$body = '';
$footer = '';

} # end resetvar()


sub printvar {

#$title =~ s/(\$\w+)/$1/eeg;
#$body =~ s/(\$\w+)/$1/eeg;

  if ($pid eq 'a') {
$template =<< "PIDA";
# $maintitle
## $mainsubtitle
## $author
### $rights - $date

---

PIDA
  } else {
$template =<< "PIDNUM";
## <a id="$pid">$pid</a> - $title 

$image

$body

$footer

---

PIDNUM
  }
  
  #print "\n\nOUTPUT HERE...\n\n";
  $template =~ s/(\$\w+)/$1/eeg;
  print $template;
  
} #end printvar()  



#Begin Main Loop
while (<>) {
  if (/^pid:/ && $mode==0) { $mode=1; resetvar(); }
  if (/^\s*$/ && $mode==1) { $mode=2; }
  if (/^pid:/ && $mode==2) { $mode=1; printvar(); resetvar(); }
  
  if ($mode==1) {
    m/^(\w+):\s*(.*)\s+$/;
    $p1=$1; $p2=$2;
    if ($p1 eq "image") {
      $inp=$p2;
      $inp=~ s/(\w+\.(png|jpg)),\s*(.+)/\!\[$3\]\($1\)/;
      $image = "$inp\n";
    } elsif ($p1 eq "link") {
	   $inp=$p2;
      $inp=~ s/(\w+),\s*(.+)/\n\- \[$2\]\(\#$1\)/;
		$footer .= "$inp";
    } else {
	   $inp="\$$p1=\'$p2\';";
	   eval $inp;
	 }
  }

} continue {
  if ($mode==2) {
    $body .= $_;
  } 
  #print;
}

$mode=3; printvar();

#end testing
